---
title: ChildNode
slug: Web/API/ChildNode
tags:
  - API
  - DOM
  - Experimental
  - Interface
  - Node
---
<p>{{APIRef("DOM")}}</p>

<p><span class="seoSummary">The <code><strong>ChildNode</strong></code> mixin contains methods and properties that are common to all types of {{domxref("Node")}} objects that can have a parent.</span> It's implemented by {{domxref("Element")}}, {{domxref("DocumentType")}}, and {{domxref("CharacterData")}} objects.</p>

<h2 id="Properties">Properties</h2>

<p><em>There are neither inherited, nor specific properties.</em></p>

<h2 id="Methods">Methods</h2>

<p><em>There are no inherited methods.</em></p>

<dl>
 <dt>{{domxref("ChildNode.remove()")}} {{experimental_inline}}</dt>
 <dd>Removes this <code>ChildNode</code> from the <code>children</code> list of its parent.</dd>
 <dt>{{domxref("ChildNode.before()")}} {{experimental_inline}}</dt>
 <dd>Inserts a set of {{domxref("Node")}} or {{domxref("DOMString")}} objects in the <code>children</code> list of this <code>ChildNode</code>'s parent, just before this <code>ChildNode</code>. {{domxref("DOMString")}} objects are inserted as equivalent {{domxref("Text")}} nodes.</dd>
 <dt>{{domxref("ChildNode.after()")}} {{experimental_inline}}</dt>
 <dd>Inserts a set of {{domxref("Node")}} or {{domxref("DOMString")}} objects in the <code>children</code> list of this <code>ChildNode</code>'s parent, just after this <code>ChildNode</code>. {{domxref("DOMString")}} objects are inserted as equivalent {{domxref("Text")}} nodes.</dd>
 <dt>{{domxref("ChildNode.replaceWith()")}} {{experimental_inline}}</dt>
 <dd>Replaces this <code>ChildNode</code> in the <code>children</code> list of its parent with a set of {{domxref("Node")}} or {{domxref("DOMString")}} objects. {{domxref("DOMString")}} objects are inserted as equivalent {{domxref("Text")}} nodes.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#interface-childnode', 'ChildNode')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Split the <code>ElementTraversal</code> interface in {{domxref("ParentNode")}} and <code>ChildNode</code>. <code>previousElementSibling</code> and <code>nextElementSibling</code> are now defined on the latter. The {{domxref("CharacterData")}} and {{domxref("DocumentType")}} implemented the new interfaces. Added the <code>remove()</code>, <code>before()</code>, <code>after()</code> and <code>replaceWith()</code> methods.</td>
  </tr>
  <tr>
   <td>{{SpecName('Element Traversal', '#interface-elementTraversal', 'ElementTraversal')}}</td>
   <td>{{Spec2('Element Traversal')}}</td>
   <td>Added the initial definition of its properties to the <code>ElementTraversal</code> pure interface and use it on {{domxref("Element")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Polyfill">Polyfill</h2>

<p>External on GitHub: <code><a href="https://github.com/seznam/JAK/blob/master/lib/polyfills/childNode.js">childNode.js</a></code></p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ChildNode")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("ParentNode")}} interface</li>
 <li>
  <div class="syntaxbox">Object types implementing the {{domxref("ParentNode")}} interface</div>

  <ul>
   <li>
    <div class="syntaxbox">{{domxref("CharacterData")}}</div>
   </li>
   <li>
    <div class="syntaxbox">{{domxref("Element")}}</div>
   </li>
   <li>
    <div class="syntaxbox">{{domxref("DocumentType")}}</div>
   </li>
  </ul>
 </li>
 <li>
  <div class="syntaxbox">The {{domxref("NonDocumentTypeChildNode")}} interface</div>
 </li>
</ul>
